<template>
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        Lista de funcionários
                        <button
                            class="btn btn-primary btn-sm"
                            @click="openModalCreate"
                            data-toggle="modal"
                            data-target="#modalCreate"
                        >
                            <i class="fa fa-plus"></i> Criar
                        </button>
                        <a
                            href="http://localhost:8000/logs"
                            class="btn btn-success btn-sm"
                        >
                            <i class="fa fa-file"></i> Log
                        </a>
                    </div>

                    <div class="card-body">
                        <div class="row">
                            <div class="col-lg-3">
                                <label for="filter">Filtrar por nome:</label>
                                <input
                                    type="text"
                                    class="form-control"
                                    id="filter"
                                    v-model="filter"
                                    @change="updateList"
                                />
                            </div>
                        </div>
                        <div class="row">
                            &nbsp;
                        </div>
                        <table class="table table-bordered">
                            <thead>
                                <tr>
                                    <td>#</td>
                                    <td>Nome</td>
                                    <td>E-mail</td>
                                    <td>Login</td>
                                    <td>Salário</td>
                                    <td>Funções</td>
                                    <td>Ações</td>
                                </tr>
                            </thead>
                            <tbody v-if="!loading">
                                <tr
                                    v-for="employee in employees"
                                    :key="employee.id"
                                >
                                    <td>{{ employee.id }}</td>
                                    <td>{{ employee.user.name }}</td>
                                    <td>{{ employee.user.email }}</td>
                                    <td>{{ employee.user.login }}</td>
                                    <td>{{ employee.salary | real }}</td>
                                    <td>{{ employee.description_function }}</td>
                                    <td>
                                        <button
                                            :href="employee.id"
                                            class="btn btn-success btn-sm"
                                            @click="openModalUpdate(employee)"
                                            data-toggle="modal"
                                            data-target="#modalUpdate"
                                        >
                                            <i class="fa fa-pencil"></i>
                                        </button>
                                        <button
                                            :href="employee.id"
                                            class="btn btn-danger btn-sm"
                                            @click="openModalDelete(employee)"
                                            data-toggle="modal"
                                            data-target="#modalDelete"
                                        >
                                            <i class="fa fa-trash"></i>
                                        </button>
                                    </td>
                                </tr>
                            </tbody>
                            <tbody v-else>
                                <tr>
                                    <td colspan="7">
                                        <p class="text-center">Carregando...</p>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <nav aria-label="Paginação">
                            <ul
                                class="pagination"
                                v-if="pagination.total_pages > 0"
                            >
                                <li class="page-item">
                                    <button
                                        class="page-link"
                                        @click="
                                            loadEmployees(pagination.prev_url)
                                        "
                                        aria-label="Previous"
                                    >
                                        <span aria-hidden="true">&laquo;</span>
                                        <span class="sr-only">Anterior</span>
                                    </button>
                                </li>

                                <li
                                    :class="{
                                        'page-item': true,
                                        active:
                                            pagination.current_page ===
                                            numberPage
                                    }"
                                    v-for="numberPage in pagination.total_pages"
                                    :key="numberPage"
                                >
                                    <button
                                        class="page-link"
                                        @click="
                                            loadEmployees(
                                                pagination.path +
                                                    `?page=${numberPage}`
                                            )
                                        "
                                    >
                                        {{ numberPage }}
                                    </button>
                                </li>

                                <li class="page-item">
                                    <button
                                        class="page-link"
                                        @click="
                                            loadEmployees(pagination.next_url)
                                        "
                                        aria-label="Next"
                                    >
                                        <span aria-hidden="true">&raquo;</span>
                                        <span class="sr-only">Próxima</span>
                                    </button>
                                </li>
                            </ul>
                            <ul class="pagination" v-else>
                                <li class="page-item disabled">
                                    <button
                                        class="page-link"
                                        @click="
                                            loadEmployees(pagination.prev_url)
                                        "
                                        aria-label="Previous"
                                    >
                                        <span aria-hidden="true">&laquo;</span>
                                        <span class="sr-only">Anterior</span>
                                    </button>
                                </li>

                                <li class="page-item active">
                                    <button class="page-link">
                                        1
                                    </button>
                                </li>

                                <li class="page-item disabled">
                                    <button
                                        class="page-link"
                                        @click="
                                            loadEmployees(pagination.next_url)
                                        "
                                        aria-label="Next"
                                    >
                                        <span aria-hidden="true">&raquo;</span>
                                        <span class="sr-only">Próxima</span>
                                    </button>
                                </li>
                            </ul>
                        </nav>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="showModalDelete" id="modalDelete">
            <div
                class="modal"
                tabindex="1"
                role="dialog"
                :style="showModalDelete ? 'display: block;' : 'display: none;'"
            >
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Excluir funcionário</h5>
                            <button
                                type="button"
                                class="close"
                                data-dismiss="modal"
                                aria-label="Close"
                            >
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <div v-if="validationErrors">
                                <ul class="alert alert-danger">
                                    <li
                                        v-for="(errors,
                                        key,
                                        index) in validationErrors"
                                    >
                                        {{ errors[0] }}
                                    </li>
                                </ul>
                            </div>
                            <p>
                                Deseja excluir o funcionário
                                {{ employeeActive.user.name }}?
                            </p>
                        </div>
                        <div class="modal-footer">
                            <button
                                type="button"
                                class="btn btn-primary"
                                @click="deleteEmployee(employeeActive.id)"
                            >
                                Sim
                            </button>
                            <button
                                type="button"
                                class="btn btn-secondary"
                                data-dismiss="modal"
                                @click="closeModalDelete"
                            >
                                Não
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="showModalUpdate" id="modalUpdate">
            <div
                class="modal"
                tabindex="1"
                role="dialog"
                :style="showModalUpdate ? 'display: block;' : 'display: none;'"
            >
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Atualizar funcionário</h5>
                            <button
                                type="button"
                                class="close"
                                data-dismiss="modal"
                                aria-label="Close"
                            >
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <div v-if="validationErrors">
                                <ul class="alert alert-danger">
                                    <li
                                        v-for="(errors,
                                        key,
                                        index) in validationErrors"
                                    >
                                        {{ errors[0] }}
                                    </li>
                                </ul>
                            </div>
                            <form action="#" @submit="event.preventDefault()">
                                <div class="row">
                                    <div class="col-lg-4">
                                        <label for="name">Nome</label>
                                        <input
                                            type="text"
                                            class="form-control"
                                            id="name"
                                            v-model="employeeActive.user.name"
                                            name="name"
                                            aria-describedby="nome"
                                            required
                                        />
                                        <small
                                            id="nameHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="email">Email</label>
                                        <input
                                            type="email"
                                            class="form-control"
                                            id="email"
                                            v-model="employeeActive.user.email"
                                            name="email"
                                            aria-describedby="email"
                                            required
                                        />
                                        <small
                                            id="emailHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="login">Login</label>
                                        <input
                                            type="text"
                                            class="form-control"
                                            id="login"
                                            v-model="employeeActive.user.login"
                                            name="login"
                                            aria-describedby="login"
                                            required
                                        />
                                        <small
                                            id="loginHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                </div>
                                <div class="row">&nbsp;</div>
                                <div class="row">
                                    <div class="col-lg-4">
                                        <label for="salary">Salário</label>
                                        <input
                                            type="text"
                                            class="form-control"
                                            id="salary"
                                            v-model="employeeActive.salary"
                                            name="salary"
                                            aria-describedby="salary"
                                            required
                                        />
                                        <small
                                            id="salaryHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="date_birthday"
                                            >Data de nascimento</label
                                        >
                                        <input
                                            type="date"
                                            class="form-control"
                                            id="date_birthday"
                                            v-model="
                                                employeeActive.date_birthday
                                            "
                                            name="date_birthday"
                                            aria-describedby="date_birthday"
                                            required
                                        />
                                        <small
                                            id="date_birthdayHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="description_function"
                                            >Descrição</label
                                        >
                                        <textarea
                                            type="text"
                                            class="form-control"
                                            id="description_function"
                                            v-model="
                                                employeeActive.description_function
                                            "
                                            name="description_function"
                                            aria-describedby="salary"
                                            required
                                        ></textarea>
                                        <small
                                            id="description_functionHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button
                                type="button"
                                class="btn btn-primary"
                                @click="updateEmployee(employeeActive.id)"
                            >
                                Atualizar
                            </button>
                            <button
                                type="button"
                                class="btn btn-secondary"
                                data-dismiss="modal"
                                @click="closeModalUpdate"
                            >
                                Cancelar
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div v-if="showModalCreate" id="modalCreate">
            <div
                class="modal"
                tabindex="1"
                role="dialog"
                :style="showModalCreate ? 'display: block;' : 'display: none;'"
            >
                <div class="modal-dialog modal-lg" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h5 class="modal-title">Cadastrar funcionário</h5>
                            <button
                                type="button"
                                class="close"
                                data-dismiss="modal"
                                aria-label="Close"
                            >
                                <span aria-hidden="true">&times;</span>
                            </button>
                        </div>
                        <div class="modal-body">
                            <div v-if="validationErrors">
                                <ul class="alert alert-danger">
                                    <li
                                        v-for="(errors,
                                        key,
                                        index) in validationErrors"
                                    >
                                        {{ errors[0] }}
                                    </li>
                                </ul>
                            </div>
                            <form action="#" @submit="event.preventDefault()">
                                <div class="row">
                                    <div class="col-lg-4">
                                        <label for="name">Nome</label>
                                        <input
                                            type="text"
                                            class="form-control"
                                            id="name"
                                            v-model="employeeActive.user.name"
                                            name="name"
                                            aria-describedby="nome"
                                            required
                                        />
                                        <small
                                            id="nameHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="email">Email</label>
                                        <input
                                            type="email"
                                            class="form-control"
                                            id="email"
                                            v-model="employeeActive.user.email"
                                            name="email"
                                            aria-describedby="email"
                                            required
                                        />
                                        <small
                                            id="emailHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="login">Login</label>
                                        <input
                                            type="text"
                                            class="form-control"
                                            id="login"
                                            v-model="employeeActive.user.login"
                                            name="login"
                                            aria-describedby="login"
                                            required
                                        />
                                        <small
                                            id="loginHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                </div>
                                <div class="row">
                                    <div class="col-lg-6">
                                        <label for="password">Senha</label>
                                        <input
                                            id="password"
                                            type="password"
                                            class="form-control"
                                            v-model="
                                                employeeActive.user.password
                                            "
                                            name="password"
                                            required
                                        />
                                    </div>
                                    <div class="col-lg-6">
                                        <label for="password-confirm"
                                            >Confirmar senha</label
                                        >
                                        <input
                                            id="password-confirm"
                                            type="password"
                                            class="form-control"
                                            v-model="
                                                employeeActive.user
                                                    .confirmpassword
                                            "
                                            name="password_confirmation"
                                            required
                                        />
                                    </div>
                                </div>
                                <div class="row">&nbsp;</div>
                                <div class="row">
                                    <div class="col-lg-4">
                                        <label for="salary">Salário</label>
                                        <input
                                            type="text"
                                            class="form-control"
                                            id="salary"
                                            v-model="employeeActive.salary"
                                            name="salary"
                                            aria-describedby="salary"
                                            required
                                        />
                                        <small
                                            id="salaryHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="date_birthday"
                                            >Data de nascimento</label
                                        >
                                        <input
                                            type="date"
                                            class="form-control"
                                            id="date_birthday"
                                            v-model="
                                                employeeActive.date_birthday
                                            "
                                            name="date_birthday"
                                            aria-describedby="date_birthday"
                                            required
                                        />
                                        <small
                                            id="date_birthdayHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                    <div class="col-lg-4">
                                        <label for="description_function"
                                            >Descrição</label
                                        >
                                        <textarea
                                            type="text"
                                            class="form-control"
                                            id="description_function"
                                            v-model="
                                                employeeActive.description_function
                                            "
                                            name="description_function"
                                            aria-describedby="salary"
                                            required
                                        ></textarea>
                                        <small
                                            id="description_functionHelp"
                                            class="form-text text-muted"
                                            >Campo obrigatório</small
                                        >
                                    </div>
                                </div>
                            </form>
                        </div>
                        <div class="modal-footer">
                            <button
                                type="button"
                                class="btn btn-primary"
                                @click="createEmployee"
                            >
                                Cadastrar
                            </button>
                            <button
                                type="button"
                                class="btn btn-secondary"
                                data-dismiss="modal"
                                @click="closeModalCreate"
                            >
                                Cancelar
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    mounted() {
        this.loadEmployees();
    },
    methods: {
        updateList: function() {
            let isto = this;
            this.employees = this.employees.filter(function(employee) {
                const lowerName = employee.user.name.toLowerCase();
                return lowerName.indexOf(isto.filter.toLowerCase()) > -1;
            });
        },
        loadEmployees: async function(url = `${this.host}/employees?page=1`) {
            // Se passar null, o javascript não usar o valor default -_-
            if (!url) return;
            this.loading = true;
            // Aceita ES6 sem fazer configurações \o/
            try {
                let response = await axios.get(url);
                // 1º .data = transform do axios -_- (no postman, não tem 2 .data)
                // 2º .data = paginate laravel
                this.employees = response.data.data;
                this.pagination = {
                    path: response.data.path,
                    current_page: response.data.current_page,
                    first_url: response.data.first_page_url,
                    last_url: response.data.last_page_url,
                    prev_url: response.data.prev_page_url,
                    next_url: response.data.next_page_url,
                    total_pages: parseInt(
                        response.data.total / response.data.per_page
                    )
                };
                if (this.message) {
                    alert(this.message);
                    this.message = null;
                }
                this.loading = false;
            } catch (error) {
                console.log(error);
            }
        },
        openModalDelete: function(employee) {
            this.employeeActive = employee;
            this.showModalDelete = true;
            this.validationErrors = null;
        },
        closeModalDelete: function() {
            this.employeeActive = null;
            this.showModalDelete = false;
            $('#modalDelete').modal('hide');
        },
        deleteEmployee: async function(id) {
            try {
                const response = await axios.delete(
                    `${this.host}/employees/delete/${id}`
                );
                this.employees = this.employees.filter(function(employee) {
                    return employee.id !== id;
                });
                alert("Excluído com sucesso!");
                this.closeModalDelete();
            } catch (error) {
                console.log(error);
            }
        },
        openModalUpdate: function(employee) {
            this.employeeActive = employee;
            this.showModalUpdate = true;
            this.validationErrors = null;
        },
        closeModalUpdate: function() {
            this.employeeActive = null;
            this.showModalUpdate = false;
            $('#modalUpdate').modal('hide');
        },
        updateEmployee: function(id) {
            // little trick
            let isto = this;
            axios
                .put(`${this.host}/employees/update/${id}`, {
                    user_info: {
                        ...this.employeeActive.user
                    },
                    employee_info: {
                        ...this.employeeActive
                    }
                })
                .then(function(response) {
                    isto.loadEmployees(
                        `${isto.host}/employees?page=${isto.pagination.current_page}`
                    );
                    isto.message = "Atualizado com sucesso!";
                    isto.closeModalUpdate();
                })
                .catch(function(error) {
                    if (error.response.status === 422) {
                        isto.validationErrors = error.response.data.errors;
                        console.log(isto.validationErrors);
                    }
                });
        },
        openModalCreate: function() {
            this.validationErrors = null;
            this.employeeActive = {
                salary: null,
                description_function: null,
                date_birthday: null,
                password: null,
                confirmpassword: null,
                user: {
                    name: null,
                    email: null,
                    login: null
                }
            };
            this.showModalCreate = true;
        },
        createEmployee: function() {
            let isto = this;
            if (
                this.employeeActive.user.password !==
                this.employeeActive.user.confirmpassword
            ) {
                alert("As senhas não são identicas.");
                return;
            }
            axios
                .post(`${this.host}/employees/save`, {
                    user_info: {
                        ...this.employeeActive.user
                    },
                    employee_info: {
                        ...this.employeeActive
                    }
                })
                .then(function(response) {
                    isto.loadEmployees(
                        `${isto.host}/employees?page=${isto.pagination.current_page}`
                    );
                    isto.message = "Cadastrado com sucesso!";
                    isto.closeModalCreate();
                })
                .catch(function(error) {
                    if (error.response.status === 422) {
                        isto.validationErrors = error.response.data.errors;
                        console.log(isto.validationErrors);
                    }
                });
        },
        closeModalCreate: function() {
            this.employeeActive = null;
            this.showModalCreate = false;
            $('#modalCreate').modal('hide');
        }
    },
    data: function() {
        return {
            host: "http://localhost:8000/api",
            loading: false,
            showModalDelete: false,
            showModalUpdate: false,
            showModalCreate: false,
            pagination: {},
            employees: [],
            employeeActive: null,
            validationErrors: null,
            filter: null
        };
    },
    filters: {
        real: function(value) {
            let salary = value.toString();
            salary = salary.replace(".", ",");
            return `R$ ${salary}`;
        }
    }
};
</script>
